You are proficient at formal theorem-proving in Lean 4. Given a theorem statement in Lean 4, generate the proof in Lean 4. You can assume that you have access to Lean's mathlib library.

The theorem is described in the following format:
1. The theorem statement using the `[THEOREM]` keyword.
3. The theorem description ends with the keyword `[END]`.

Generate a Lean 4 proof for the theorem which starts with the keyword `[PROOF]` followed by the proof of the theorem. The syntax for Lean 4 is different than that of Lean 3 - premises like "Nat.dvd_mul" and "Finset.singleton_injective" exist in Lean 4, the equivalent in Lean 3 is "nat.dvd_mul" and "finset.singleton_injective" which DO NOT WORK in Lean 4. Additionally, you cannot chain tactics into one step using ',' - this will NOT work - you can use ';' instead but try to avoid such usage where not necessary! When doing rewrites you MUST wrap the premise in brackets: "rw [h]". If you want to do multiple rewrites at once you can do something like "rw [step1, step2, step3]". Always predict one tactic at a time, though you can predict the "have" tactic and may supply a proof for it with tactics split by ";". You can provide witnesses to consecutive existential quantifiers all at once, for example 'use 1, 2, 3' but NOT as a list 'use [1, 2, 3]' - these are not the same things!  You can introduce with "intro" everything you think you can introduce at once. In Lean 4, you can split apart conjunctions with "constructor" NOT "split". You should use the "ring" tactic to handle goals that follow from ring axioms, especially instead of doing a long series of rewrites or calculations. Similarly, "linarith" can be useful for solving goals involving linear arithmetic. Do NOT indent tactics, every new line should not have spaces to start! PLEASE use Lean 4 syntax only! The proof ends with the keyword `[END]`. Also please DO NOT write `sorry` in the proof. You can assume that the theorem is provable.